package jcg.zheng.demo;

import static org.junit.Assert.assertEquals;

import org.junit.Test;

public abstract class TestBase {

	private static final String HELLO_EVERYONE_FROM_JCG = "Hello Everyone from JCG";
	private static final String EVERYONE = "Everyone ";
	private static final String HELLO_FROM_JCG = "Hello from JCG";
	protected StringBuilder sb;

	public TestBase() {
		super();
	}

	protected void clear() {
		if (sb.length() >= 1) {
			sb.delete(0, sb.length());
			assertEquals(0, sb.length());
		}
	}
	
	@Test
	public void test_append_boolean() {
		sb.append(true);
		sb.append(false);
		assertEquals("truefalse", sb.toString());
	}

	@Test
	public void test_append_char() {
		sb.append('|');
		assertEquals("|", sb.toString());
	}
	
	@Test
	public void test_append_charArray() {
		char[] abc = {'a', 'b', 'c'};
		sb.append(abc);
		assertEquals("abc", sb.toString());
	}
	
	@Test
	public void test_append_double() {
		sb.append(123.456);
		assertEquals("123.456", sb.toString());
	}
	
	@Test
	public void test_append_object() {
		sb.append(new POJOExample("Mary", 1));
		assertEquals("POJOExample [name=Mary, id=1]", sb.toString());
	}

	@Test
	public void test_append_string() {
		sb.append(HELLO_FROM_JCG);
		assertEquals(HELLO_FROM_JCG, sb.toString());
	}
	
	@Test
	public void test_append_anotherSB() {
		StringBuilder sb2 = new StringBuilder("New Value");
		sb.append(sb2);
		assertEquals("New Value", sb.toString());
	}

	@Test
	public void test_delete() {
		sb.append(HELLO_FROM_JCG);
		sb.delete(6, 11);
		assertEquals("Hello JCG", sb.toString());
	}

	@Test
	public void test_insert() {
		sb.append(HELLO_FROM_JCG);
		sb.insert(6, EVERYONE);
		assertEquals(HELLO_EVERYONE_FROM_JCG, sb.toString());
	}

}